// definiere Interface
interface Randomizeable {
  // implementierende Klassen enthalten folgende Methoden:
  void randomize();
  void plot();
}

// definiere Klasse, die Interface implementiert
class A implements Randomizeable {
  // Felder: Koordinaten, Rotation und Größe
  float x,y,a,s;
  
  // Konstruktor
  public A (float x, float y, float s) {
    // setze übergebene Werte
    this.x = x;
    this.y = y;
    this.s = s;
  }
  
  // implementiere Methode des Interface
  void randomize () {
    // Rotation wird zufällig bestimmt
    a = a*0.7 + 0.3*random(PI);
  }
  
  // implementiere Methode des Interface
  void plot () {
    // zeichne Rechteck mit Rotation um eigenen Mittelpunkt
    pushMatrix();
    fill(255);
    // verschiebe zu Zielposition
    translate(x,y);
    // drehe um Winkel
    rotate(a);
    // Rechteck mit Mittelpunkt aud Ursprung
    rect(-s/2,-s/2,s,s);
    popMatrix();
  }
}

// definiere Klasse, die Interface implementiert
class B implements Randomizeable {
  // felder: Position, Größe, Farbe
  float x,y,s;
  color c;
  
  // Konstruktor
  public B (float x, float y, float s) {
    // setze übergebene Werte
    this.x = x;
    this.y = y;
    this.s = s;
    // Farbe gleich weiß
    c = color(255);
  }
  
  // implementiere Methode des Interface
  void randomize () {
    // zufällige Farbe
    c = color(random(255));
  }
  
  // implementiere Methode des Interface
  void plot () {
    // zeichne Kreis mit passender Farbe
    fill(c);
    ellipse(x,y,s,s);
  }
}

// Liste von Objekten mit Inteface vom Typ Randomizeable
Randomizeable[] r;

void setup () {
  size(800,800);
  // initialisiere Liste mit konkreten Werten
  r = new Randomizeable[] {
    new A(400,400,100),
    new B(200,600,200)
  };
}

void draw () {
  // fülle Hintergrund
  background(0);
  // führe für jedes Element der Liste die Methoden randomize() und plot() aus
  for (int i=0; i<r.length; i++) {
    r[i].randomize();
    r[i].plot();
  }
}